<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

// store
import { useMaterialStore } from '@/stores/material'
import { useStockStore } from '../../stores/checkstock'
import { useStockBillStore } from '@/stores/stockbill'

// View
import MaterialTable from './MaterialTable.vue'
import InvoiceDialogView from './InvoiceDialogView.vue'

//type
import type { Stock } from '@/types/Stock'
import type { StockItem } from '@/types/StockItem'
import type { Material } from '@/types/Material'
import type { StockBill } from '@/types/StockBill'
import type { StockBillDetail } from '@/types/StockBillDetail'

const stockStore = useStockStore()
const materialStore = useMaterialStore()
const bill = useStockBillStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)
const divReceiptItems = ref<HTMLElement | null>(null)

function onSubmit() {}
function closeDialog() {
  stockStore.dialog = false
  stockStore.dialogDelete = false
  stockStore.editItemDialog = false
  stockStore.addNewMaterialDialog = false
  nextTick(() => {
    stockStore.minimum = 0
    stockStore.name = ''
    stockStore.typ = ''
    stockStore.editStockItem = Object.assign({}, stockStore.initStockItem)
    materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  console.log(valid)
  if (!valid) return
  await stockStore.addNewMaterial()
  closeDialog()
}

const selectedMaterial = ref<Material | undefined>()

function addMat() {
  if (selectedMaterial.value) {
    console.log('addMat: ', selectedMaterial.value)
    selected(selectedMaterial.value)
  } else {
    console.error('addMat: selectedMaterial is undefined')
  }
}

const selected = (material: Material) => {
  console.log('materialInv: ', material)
  if (material) {
    stockStore.addItem(material)
    nextTick(() => {
      if (divReceiptItems.value)
        divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
    })
  }
}
const headersStockItem = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'ชื่อ',
    key: 'name',
    value: 'name'
  },
  {
    title: 'จำนวนที่มี',
    key: 'QOH',
    value: 'QOH'
  },
  {
    title: 'ลบวัตถุดิบ',
    key: 'actions'
  }
]
</script>

<template>
  <v-dialog v-model="stockStore.addSomeDialog">
    <v-sheet border title="Addsome">
      <div class="d-flex align-center justify-end" style="padding: 5px"></div>
      <v-divider class="border-opacity-50"></v-divider>
      <div style="padding: 0px">
        <div class="align-center">
          <h2 class="text-h4 font-weight-black">Check Stock</h2>
          <p>การเช็คจำนวนวัตถุดิบที่เหลืออยู่ในคลัง</p>
        </div>
        <v-divider class="border-opacity-50"></v-divider>
      </div>
      <!-- addItem to ItemDetail -->
      <div style="padding-top: 5px; height: 100 px" class="d-flex justify-start">
        <v-row class="d-flex justify-start">
          <v-col cols="12" sm="6" md="4">
            <v-select
              style="padding-top: 12px"
              :item-title="(item) => item.name"
              :item-value="(item) => item"
              :items="materialStore.materials"
              :rules="[(v) => !!v || 'Item is required']"
              v-model="selectedMaterial"
              label="Item"
              required
            ></v-select>
          </v-col>

          <v-col cols="12" sm="6" md="4">
            <v-text-field
              style="padding-top: 12px"
              v-model="stockStore.qoh"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              class="mb-2"
              type="number"
              clearable
              label="จำนวน"
            >
            </v-text-field>
          </v-col>
          <v-col cols="12" sm="6" md="3" style="padding-top: 20px">
            <v-btn
              color="blue-lighten-1"
              icon="mdi-language-markdown"
              size="small"
              @click="addMat"
            ></v-btn>
          </v-col>
          <v-col cols="12" sm="6" md="3">
            <v-dialog v-model="stockStore.addNewMaterialDialog" persistent width="500">
              <template v-slot:activator="{ props }">
                <v-btn color="blue-lighten-1" v-bind="props" icon="mdi-plus" size="small"> </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <span class="text-h5">New Material</span>
                </v-card-title>
                <v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="stockStore.name"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="ชื่อวัตถุดิบ"
                            :type="'string'"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="stockStore.minimum"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            :type="'number'"
                            clearable
                            label="จำนวนขั้นต่ำ"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="stockStore.editStockItem.QOH"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            :type="'number'"
                            clearable
                            label="จำนวนที่มีอยู่"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="stockStore.typ"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            :type="'string'"
                            class="mb-2"
                            clearable
                            label="หน่วยเรียก"
                            single-line
                          ></v-text-field>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form>
                  <small>*indicates required field</small>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="red-accent-3" variant="outlined" @click="closeDialog()">
                    Close
                  </v-btn>
                  <v-btn color="blue-darken-1" variant="outlined" @click="save()"> Save </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-col>
        </v-row>
      </div>
      <v-divider class="border-opacity-50"></v-divider>
      <v-data-table
        :headers="headersStockItem"
        :items="stockStore.stockItems"
        :items-per-page="stockStore.stockItems.length"
        height="300"
        fixed-header
        hide-default-footer
        disable-pagination
        class="flex-table"
        overflow-y="hidden"
      >
        <template v-slot:item="{ item }">
          <tr>
            <td>{{ item.id }}</td>
            <td>{{ stockStore.getMaterialName(item.materialId) }}</td>
            <td>
              <v-text-field
                class="d-flex align-center"
                style="padding: 0px"
                variant="outlined"
                rounded="2"
                :rules="[(v) => !!v || 'Field is required']"
                :type="'number'"
                background-color="primary"
                v-model="item.QOH"
                clearable
              ></v-text-field>
            </td>
            <td>
              <v-icon
                icon="mdi-delete-circle"
                size="large"
                color="red"
                @click="stockStore.deleteItemSome(item)"
              ></v-icon>
            </td>
          </tr>
        </template>
      </v-data-table>
      <div class="d-flex align-center justify-end">
        <v-btn @click="stockStore.close" color="red">Clear</v-btn>
        <v-btn @click="stockStore.updateQOHItems" color="primary">Save</v-btn>
      </div>
    </v-sheet>
  </v-dialog>
</template>
@/types/StockIDetail../../stores/stock
